// m@X(X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x400*5*80];

D88 disk;
FILE *fp;

bool xcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	// t@CfR[h
	for (int i=0; i<_size; i++) {
		buff[_offset+i]^=0x38;
	}
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int ofs;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,dn;
	unsigned char id1[] = " - Valis -   Sys ";
	unsigned char id2[] = "Valis ???    Sys ";

	// OPMpȃf[^(Disk 1)
	struct fpos ma1[] = {
		{ 0x03, 0x03, 0x0000, 0x0b00 },	// The Fantasm Soldier VALIS
		{ 0x0b, 0x04, 0x0000, 0x1200 },	// HAPPY END
		{ 0x0d, 0x01, 0x0000, 0x0300 },	// REIKO CHAN
		{ 0x0d, 0x02, 0x0000, 0x1200 },	// BAD ENDING
		{ 0x4d, 0x05, 0x0000, 0x0300 },	// AKU HENSHIN
		{ 0x4e, 0x01, 0x0000, 0x0200 },	// HENSHIN
//		{ 0x07, 0x05, 0x0152, 0x0100 },	// IPL
		{ 0x00, 0x00, 0x0000, 0x0000 },	// End of DATA
	};

	// PSGpȃf[^(Disk 1)
	struct fpos mb1[] = {
		{ 0x04, 0x01, 0x0000, 0x0600 },	// The Fantasm Soldier VALIS
		{ 0x0e, 0x02, 0x0000, 0x0700 },	// HAPPY END
		{ 0x0c, 0x05, 0x0000, 0x0200 },	// REIKO CHAN
		{ 0x0d, 0x05, 0x0000, 0x0600 },	// BAD ENDING
		{ 0x4e, 0x02, 0x0000, 0x0100 },	// AKU HENSHIN
		{ 0x4e, 0x02, 0x0200, 0x0100 },	// HENSHIN
		{ 0x00, 0x00, 0x0000, 0x0000 },	// End of DATA
	};

	// OPMpȃf[^(Disk 2)
	struct fpos ma2[] = {
		{ 0x23, 0x05, 0x0000, 0x0300 },	// Big Character
		{ 0x24, 0x01, 0x0000, 0x0500 },	// BGM 1
		{ 0x24, 0x03, 0x0000, 0x0500 },	// BGM 2
		{ 0x24, 0x05, 0x0000, 0x0300 },	// BGM 3
		{ 0x25, 0x01, 0x0000, 0x0b00 },	// BGM 4
		{ 0x25, 0x03, 0x0000, 0x0300 },	// BGM 5
		{ 0x25, 0x04, 0x0000, 0x0300 },	// BGM 6
		{ 0x25, 0x05, 0x0000, 0x0400 },	// PINCH
		{ 0x00, 0x00, 0x0000, 0x0000 },	// End of DATA
	};

	// PSGpȃf[^(Disk 2)
	struct fpos mb2[] = {
		{ 0x4f, 0x03, 0x0000, 0x0300 },	// Big Character
		{ 0x4d, 0x04, 0x0000, 0x0300 },	// BGM 1
		{ 0x4e, 0x01, 0x0000, 0x0300 },	// BGM 2
		{ 0x4e, 0x03, 0x0000, 0x0200 },	// BGM 3
		{ 0x4e, 0x04, 0x0000, 0x0300 },	// BGM 4
		{ 0x4f, 0x01, 0x0000, 0x0200 },	// BGM 5
		{ 0x4f, 0x02, 0x0000, 0x0200 },	// BGM 6
		{ 0x4f, 0x04, 0x0000, 0x0300 },	// PINCH
		{ 0x00, 0x00, 0x0000, 0x0000 },	// End of DATA
	};

	if (argc < 2 || argc > 3) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file] {1|2}\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	if (argc==3) {
		dn = atoi(argv[2]);
	}

	int numdisk = disk.GetNumDisk();
	for (int d=0; d<numdisk; d++) {
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x13);
		disk.SetRecordRange(0x01,0x05);
		// fBXN
		if (((!memcmp(&buff[1], id1, sizeof(id1))) && dn!=2) || dn==1) {
			printf("DISK No.1 F܂.\n");
			// hCo
			xcut("OPMDRV", 0x02, 0x01, 0x00, 0x01, 0x03, 0x0000, 0x0800);
			xcut("PSGDRV", 0x02, 0x01, 0x00, 0x03, 0x03, 0x0000, 0x0800);
			// ȃf[^̐؂o
			for (i=0; ma1[i].sec; i++) {
				sprintf(fname,"MA1%02d",i);
				xcut(fname, ma1[i].trk, ma1[i].trk>>1, ma1[i].trk&1, ma1[i].sec, 0x03, ma1[i].ofs, ma1[i].size);
			}
			for (i=0; mb1[i].sec; i++) {
				sprintf(fname,"MB1%02d",i);
				xcut(fname, mb1[i].trk, mb1[i].trk>>1, mb1[i].trk&1, mb1[i].sec, 0x03, mb1[i].ofs, mb1[i].size);
			}
		}
		else if (!memcmp(&buff[1], id2, sizeof(id2)) || dn==2) {
			printf("DISK No.2 F܂.\n");
			xcut("OPMDRV2", 0x3c, 0x1e, 0x00, 0x01, 0x03, 0x0000, 0x0800);
			xcut("PSGDRV2", 0x3c, 0x1e, 0x00, 0x03, 0x03, 0x0000, 0x0600);
			xcut("VOICE",   0x0e, 0x07, 0x00, 0x01, 0x03, 0x0120, 0x0200);
			// ȃf[^̐؂o
			for (i=0; ma2[i].sec; i++) {
				sprintf(fname,"MA2%02d",i);
				xcut(fname, ma2[i].trk, ma2[i].trk>>1, ma2[i].trk&1, ma2[i].sec, 0x03, ma2[i].ofs, ma2[i].size);
			}
			for (i=0; mb2[i].sec; i++) {
				sprintf(fname,"MB2%02d",i);
				xcut(fname, mb2[i].trk, mb2[i].trk>>1, mb2[i].trk&1, mb2[i].sec, 0x03, mb2[i].ofs, mb2[i].size);
			}
		}
	}
	return 0;
}

